#include "xgrav.h"

int planetsize(planetnum)
int planetnum;

{
    return (int)pow((double)PLANETSIZELOGBASE, (double)planet[planetnum].size) * PLANETSIZEMIN;
}

int planetmass(planetnum)
int planetnum;

{
    int temp;
    
    temp = planet[planetnum].density * (int)pow((double)PLANETDENSITYLOGBASE, (double)planet[planetnum].size);
    /*much tweaking will be needed here*/
    /*tempororily, a constant (remove this later):*/
    temp = 100 * (planet[planetnum].size + 1); /*arbitrary test mass*/
    return temp;
}



void makeplanets()

{
    int temp, temp2, badplanetplace, dist;
    int tempx, tempy;

    numplanets = minplanets + (random()%((maxplanets + 1) - minplanets));
    for (temp=0; temp<numplanets; temp++) { /*loop to create all planets*/
	/*create a single planet*/
	planet[temp].size = (random() % (PLANETSIZERANGE));
	planet[temp].density = (random() % PLANETDENSITYRANGE);
	planet[temp].diameter = planetsize(temp);
	badplanetplace = 1;
	while (badplanetplace) { /*loop until place is good*/
	    badplanetplace=0;
	    tempx = (random() % GALAXYRADIUS) - (GALAXYRADIUS / 2);
	    tempy = (random() % GALAXYRADIUS) - (GALAXYRADIUS / 2);
	    if (distance((tempx + planet[temp].diameter),(tempy + planet[temp].diameter),0,0) > (GALAXYRADIUS/2))
		badplanetplace = 1;
	    for (temp2=0; temp2<temp; temp2++) {
		dist = distance(tempx, tempy, planet[temp2].x, planet[temp2].y);
		if (dist < MINPLANETSPACING)
		    badplanetplace = 1;
	    }
	} /*got a good place*/
	planet[temp].x = tempx;
	planet[temp].y = tempy;
	planet[temp].mass = planetmass(temp);
	planet[temp].surface = random() % NUMSURFACES;
    } /*that's all the planets*/
}

void placeships()

{
    int temp, temp2, badshipplace;
    int tempx, tempy;
    for (temp = 0; temp < numplayers; temp++) {
	badshipplace = 1;
	while (badshipplace) {
	    badshipplace = 0;
	    tempx = (random() % MAXSHIPRADIUS) - (MAXSHIPRADIUS/2);
	    tempy = (random() % MAXSHIPRADIUS) - (MAXSHIPRADIUS/2);
	    for (temp2=0; temp2<numplanets; temp2++) {
		if (distance(tempx, tempy, planet[temp2].x, planet[temp2].y) < (MINSHIPTOPLANETSPACING +( planet[temp2].diameter/2)+(player[temp].shipwidth/2)))
		    badshipplace = 1;
	    }
	    for (temp2=0; temp2<temp; temp2++) {
		if (distance(tempx, tempy, player[temp2].shipx, player[temp2].shipy) < MINSHIPTOSHIPSPACING)
		    badshipplace = 1;
	    }
	}
	/*got good place*/
	player[temp].shipx = tempx;
	player[temp].shipy = tempy;
    }
}

void pregame()

{
    XEvent event, nextevent;
    int numready, temp, veto, temp2;
    Bool eventp;
    char c;

    for (temp=0; temp<numplayers; temp++) { XFillRectangle(player[temp].dpy, player[temp].trails, player[temp].blackpen, 0,0,WIDE,HIGH);
    player[temp].ready = 0;
    }
    numready = 0;
    while (numready != numplayers) {
	makeplanets();
	placeships();
	numready = 0;
	veto=0;
	for (temp = 0; temp < numplayers; temp++)
	    player[temp].ready = 0;
	redrawpg();
	while (!veto && numready != numplayers)
	    for (temp=0;temp<numplayers;temp++) { /*for all players*/
		eventp = XCheckWindowEvent(player[temp].dpy, player[ temp].win, GAME_EVENT_MASKS, &event);
		if (eventp) switch (event.type) {
		    case Expose:
			eventp = XCheckWindowEvent(player[temp].dpy, player[temp].win, GAME_EVENT_MASKS, &nextevent);
			while (eventp && nextevent.type == Expose) {
			    eventp = XCheckWindowEvent(player[temp].dpy, player[temp].win, GAME_EVENT_MASKS, &nextevent);
			};
			if (eventp) {
			    XPutBackEvent(player[temp].dpy, &nextevent);
			};
			redrawpg1(temp);
			break;
		    case KeyPress:
			if (XLookupString(&event.xkey, &c, 1, NULL, NULL) == 1) {
			    switch (c) {
				case 'r':
				case 'R':
				    if (!player[temp].ready) {
					player[temp].ready = 1;
					numready++;
				    }
				    XCopyArea(player[temp].dpy, player[temp].readybutton2bm, player[temp].win, player[temp].whitepen, 0, 0, BUTWIDTH, BUTHEIGHT, player[temp].readybuttonminx, player[temp].readybuttonminy);
				    break;
				case 'v':
				case 'V':
				    veto = 1;
				    break;
			    }
			}
			break;
		    case ButtonPress:
			/* event.xbutton.button = button #;
			 event.xbutton.x and event.xbutton.y are x, y relative to window */
			if (event.xbutton.button = 1) {
			    if (event.xbutton.x > player[temp].readybuttonminx && event.xbutton.x < player[temp].readybuttonmaxx && event.xbutton.y > player[temp].readybuttonminy && event.xbutton.y < player[temp].readybuttonmaxy) {
				if (!player[temp].ready) {
				    player[temp].ready = 1;
				    numready++;
				}
				XCopyArea(player[temp].dpy, player[temp].readybutton2bm, player[temp].win, player[temp].whitepen, 0, 0, BUTWIDTH, BUTHEIGHT, player[temp].readybuttonminx, player[temp].readybuttonminy);
			    }
			    else if (event.xbutton.x > player[temp].vetobuttonminx && event.xbutton.x < player[temp].vetobuttonmaxx && event.xbutton.y > player[temp].vetobuttonminy && event.xbutton.y < player[temp].vetobuttonmaxy) {
				veto=1;

			    } /*end else if*/
			    /*else do nothing, fr now*/
			} /*end if button #1*/
			break;
		    default:
			break;
		}
	    }
    }
}
